/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive;

/**
 * Message that contains an Action.
 */
public interface ActionMessage extends Message {
	
	/**
	 * Returns the Action of this ActionMessage.
	 * @return the Action of this ActionMessage.
	 */
	public Action getAction();
	
	/**
	 * Returns the ReactiveException thrown by the Action during its execution if any,
	 *   null elsewhere.
	 * @return the ReactiveException thrown by the Action during its execution if any,
	 *   null elsewhere.
	 */
	public Exception getException();
}
