/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive;

/**
 * Agent initialization data.
 */
public interface LaunchingContext {

	/**
	 * Returns the ReactiveEntity. Cannot be null.
	 * @return the ReactiveEntity. Cannot be null.
	 */
	public ReactiveEntity getReactiveEntity();
	
	/**
	 * Returns the ReactiveCommunity. Can be null.
	 * @return the ReactiveCommunity. Can be null.
	 */
	public ReactiveCommunity getReactiveCommunity();
	
	/**
	 * Returns the ReactiveMachine. Cannot be null.
	 * @return the ReactiveMachine. Cannot be null.
	 */
	public ReactiveMachine getReactiveMachine();

	/**
	 * Returns the current status of the attached Agent, one of STATUS_* constants.
	 * @return the current status of the attached Agent, one of STATUS_* constants.
	 */
	public int getAgentStatus();
	public static final int STATUS_BEING_LAUNCHED = 0;
	public static final int STATUS_INITIALIZING = 1;
	public static final int STATUS_PARTICIPATING = 2;
	public static final int STATUS_TERMINATING = 3;
	
	/**
	 * Returns the trace PrintStream. Can be null.
	 * @return the trace PrintStream. Can be null.
	 */
	public PrintStream getTrace();
}
