/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive;

/**
 * Reordered PrintStream within each instant.
 */
public interface PrintStream {

	/**
	 * Returns the original PrintStream.
	 * @return the original PrintStream.
	 */
	public java.io.PrintStream getOriginalPrintStream();
	
	/**
	 * Displays its buffer and begins a new one.
	 * @param community the ReactiveCommunity.
	 */
	public void nextInstant(ReactiveCommunity community);
	
	/**
	 * Like java.io.PrintStream.println(String).
	 * @param text a text.
	 */
	public void println(String text);
}
