/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.agent;

import org.xmloperator.reactive.LaunchingContext;
import org.xmloperator.reactive.PrintStream;
import org.xmloperator.reactive.ReactiveCommunity;
import org.xmloperator.reactive.ReactiveEntity;
import org.xmloperator.reactive.ReactiveMachine;

final class LaunchingContextImpl implements LaunchingContext {
	
	protected final ReactiveEntity reactiveEntity;
	protected final ReactiveCommunity reactiveCommunity;
	protected final ReactiveMachine reactiveMachine;
	protected final PrintStream trace;
	protected volatile int agentStatus = LaunchingContext.STATUS_BEING_LAUNCHED;

	LaunchingContextImpl(ReactiveEntity reactiveEntity,
			ReactiveCommunity reactiveCommunity,
			ReactiveMachine reactiveMachine, PrintStream trace) {
		this.reactiveEntity = reactiveEntity;
		this.reactiveCommunity = reactiveCommunity;
		this.reactiveMachine = reactiveMachine;
		this.trace = trace;
	}

	final void setAgentStatus(int agentStatus) {
		this.agentStatus = agentStatus;
	}
	
	//////////////////////////////////
	// LaunchingContext implementation
	//////////////////////////////////

	public final ReactiveEntity getReactiveEntity() {
		return this.reactiveEntity;
	}
	
	public final ReactiveCommunity getReactiveCommunity(){
		return this.reactiveCommunity;
	}
	
	public final ReactiveMachine getReactiveMachine() {
		return this.reactiveMachine;
	}

	public final int getAgentStatus() {
		return this.agentStatus;
	}
	
	public final PrintStream getTrace() {
		return this.trace;
	}
}
