/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land;

import org.xmloperator.reactive.Message;

/**
 * Message from an AgentBody.
 */
public interface AgentBodyMessage extends Message {

	/**
	 * Possible information. It is given before leaving a Station to its
	 * occupants, excepting the sender.
	 */
	public static final Object leavingStation = new Object();

	/**
	 * Possible information. It is given after entering a Station to its
	 * occupants, excepting the sender.
	 */
	public static final Object enteringStation = new Object();

	/**
	 * @return the sender AgentBody.
	 */
	public AgentBody getAgentBody();
	
	/**
	 * @return the provided information.
	 */
	public Object getInformation();
}
