/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land;

import java.util.Random;

/**
 * Stations of a Graph, which are occupied by mobile agents.
 */
public interface Stations {

	/**
	 * @return the Graph of stations.
	 */
	public Graph getGraph();
	
	/**
	 * Returns the station with the given location. Station references are
	 * always different in order to not be identified.
	 * 
	 * @param stationIndex
	 *            the index of a Station in the Graph of stations.
	 * @return the Station.
	 */
	public Station getStation(int stationIndex);

	/**
	 * @param random a Random number generator.
	 * @return any Station.
	 */
	public Station anyStation(Random random);
	
	/**
	 * @return the number of occupant agents.
	 */
	public int getOccupantCount();
}
