/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land;

/**
 * Memory visits of the stations of a Graph.
 */
public interface VisitMemory {

	/**
	 * Memorizes a new visit to a Station.
	 * 
	 * @param stationIndex
	 *            the index of a Station.
	 */
	public void visit(int stationIndex);

	/**
	 * @param stationIndex
	 *            the index of a Station.
	 * @return the move number of the last visit of a Station.
	 */
	public int getLastVisit(int stationIndex);

	/**
	 * @return the move number of the last visit.
	 */
	public int getLastMoveNumber();

	/**
	 * @return The move number difference between the the two last visit of the
	 *         last visited Station.
	 */
	public int getLastVisitInterval();
}
