/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.action;

import org.xmloperator.reactive.demo.land.AgentLocation;
import org.xmloperator.reactive.demo.land.LandBoard;
import org.xmloperator.reactive.demo.land.Station;

import org.xmloperator.reactive.impl.ActionImpl;

/**
 * Action of an Agent that moves from a Station to another.
 */
public final class AgentMoveAction extends ActionImpl {
	private final LandBoard landBoard;
	private final AgentLocation agentLocation;
	private final Station destination;
	
	public AgentMoveAction(LandBoard landBoard, AgentLocation agentLocation,
			Station destination) {
		if (landBoard == null || agentLocation == null
				|| destination == null)
			throw new IllegalArgumentException();
		this.landBoard = landBoard;
		this.agentLocation = agentLocation;
		this.destination = destination;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public void execute(long permissionKey) {
		super.execute(permissionKey);
		this.landBoard.agentMove(permissionKey, this.agentLocation,
				this.destination);
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.agentLocation.getAgentBody() + ".move."
				+ this.agentLocation.getCurrentStation() + "."
				+ this.destination;
	}
}
