/*
 * Copyright (c) 2008, 2011 The_xmloperator_project. All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.action;

import org.xmloperator.reactive.demo.land.LandBoard;
import org.xmloperator.reactive.impl.ActionImpl;

/**
 * Action of land ending.
 */
public final class LandDoneAction extends ActionImpl {
	private final LandBoard landBoard;
	private final long donePermissionKey;
	
	public LandDoneAction(LandBoard landBoard, long donePermissionKey) {
		if (landBoard == null)
			throw new IllegalArgumentException();
		this.landBoard = landBoard;
		this.donePermissionKey = donePermissionKey;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public void execute(long boardPermissionKey) {
		super.execute(boardPermissionKey);
		this.landBoard.done(boardPermissionKey, this.donePermissionKey);
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return "landDone";
	}
}
