/*
 * Copyright (c) 2008, 2011 The_xmloperator_project. All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.agent;

import java.util.concurrent.atomic.AtomicInteger;

/**
 * Statistic on agent behavior.
 */
final class BehaviorStat {
	private AtomicInteger divisionCount = new AtomicInteger();
	private AtomicInteger mergeCount = new AtomicInteger();
	private AtomicInteger giftCount = new AtomicInteger();
	private AtomicInteger moveCount = new AtomicInteger();
	private AtomicInteger supplyCount = new AtomicInteger();
	
	BehaviorStat() {
	}
	
	void add(int divisionCount, int mergeCount, int giftCount,
			int moveCount, int supplyCount) {
		this.divisionCount.addAndGet(divisionCount);
		this.mergeCount.addAndGet(mergeCount);
		this.giftCount.addAndGet(giftCount);
		this.moveCount.addAndGet(moveCount);
		this.supplyCount.addAndGet(supplyCount);
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return "division(" + this.divisionCount
				+ ") merge(" + this.mergeCount
				+ ") gift(" + this.giftCount
				+ ") move(" + this.moveCount
				+ ") supply(" + this.supplyCount
				+ ")";
	}
}
