/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.agent;

import org.xmloperator.reactive.demo.land.NavigationStrategy;

/**
 * Gene pool of an Agent.
 */
public final class GenePool {
	private final NavigationStrategy navigationStrategy;
	
	public GenePool(NavigationStrategy navigationStrategy) {
		if (navigationStrategy == null)
			throw new IllegalArgumentException();
		this.navigationStrategy = navigationStrategy;
	}

	public NavigationStrategy getNavigationStrategy() {
		return this.navigationStrategy;
	}
	
	public GenePool almostClone(long seed) {
		return new GenePool(this.navigationStrategy.almostClone(seed));
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.navigationStrategy.toString();
	}
}
