/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.impl;

import org.xmloperator.reactive.demo.land.AgentBody;
import org.xmloperator.reactive.demo.land.AgentBodyMessage;
import org.xmloperator.reactive.impl.MessageImpl;

public class AgentBodyMessageImpl extends MessageImpl implements
		AgentBodyMessage {
	private final AgentBody agentBody;
	private final Object information;
	
	public AgentBodyMessageImpl(AgentBody agentBody, Object information) {
		if (agentBody == null)
			throw new IllegalArgumentException();
		this.agentBody = agentBody;
		this.information = information;
	}

	//////////////////////////////////
	// AgentBodyMessage implementation
	//////////////////////////////////
	
	public final AgentBody getAgentBody() {
		return this.agentBody;
	}

	public final Object getInformation() {
		return this.information;
	}
}
