/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.land.sphere.impl;

import java.text.DecimalFormat;
import java.text.NumberFormat;

import org.xmloperator.reactive.demo.land.sphere.Vector2;

/**
 * Vector2 Implementation.
 */
public final class Vector2Impl implements Vector2 {
	private static final NumberFormat formatter = new DecimalFormat("0.000");
	
	public static final String toString(double t) {
		String s = formatter.format(t);
		if (t >= 0)
			s = '+' + s;
		return s;
	}
	
	public static final double norm(double u, double v) {
		return Math.sqrt(u * u + v * v );
	}
	
	final double u;
	final double v;
	
	/**
	 * Basic constructor.
	 * @param u an u coordinate.
	 * @param v an v coordinate.
	 */
	public Vector2Impl(double u, double v) {
		this.u = u;
		this.v = v;
	}

	/////////////////////////
	// Vector2 implementation
	/////////////////////////
	
	public double getU() {
		return this.u;
	}

	public double getV() {
		return this.v;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return "(" + toString(this.u) + "," + toString(this.v) + ")";
	}
}
