/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.market;

import org.xmloperator.reactive.exception.ReactiveException;

/**
 * This exception is thrown when a source Account has insufficient sold for
 * realizing a transfer.
 */
public final class InsufficientSoldException extends ReactiveException {
	private static final long serialVersionUID = -4282732650107496928L;
	
	private final Account account;
	
	public InsufficientSoldException(Account account) {
		this.account = account;
	}
	
	public final Account getAccount() {
		return this.account;
	}
}
