/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.market.action;

import org.xmloperator.reactive.demo.market.Proposal;
import org.xmloperator.reactive.demo.market.Resource;
import org.xmloperator.reactive.impl.SimpleMessageImpl;

public final class ProposalMessage extends SimpleMessageImpl {
	protected static Resource traceableResource;
	
	public static void setTraceableResource(Resource traceableResource) {
		ProposalMessage.traceableResource = traceableResource;
	}

	public ProposalMessage(Proposal proposal) {
		super(proposal);
	}

	/////////////////////////
	// Message implementation
	/////////////////////////

	public boolean isTraceable() {
		Proposal proposal = (Proposal)this.object;
		return traceableResource == null
				|| proposal.getProposedResource() == traceableResource
				|| proposal.getPaymentResource() == traceableResource;
	}
}
