/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.demo.market.impl;

import java.math.BigInteger;

import org.xmloperator.reactive.demo.market.Transformation;
import org.xmloperator.reactive.impl.OperationImpl;

/**
 * Executor of a Transformation.
 */
final class Transform extends OperationImpl {
	private final Transformation transformation;
	private final BigInteger factor;
	
	Transform(Transformation transformation, BigInteger factor) {
		if (transformation == null || factor.compareTo(BigInteger.ONE) < 0)
			throw new IllegalArgumentException();
		this.transformation = transformation;
	this.factor = factor;
	}

	///////////////////////////
	// Operation implementation
	///////////////////////////
	
	public final void execute() {
		super.execute();
		((TransformationImpl) this.transformation).execute(this.factor);
	}
}
