/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element;

import org.xmloperator.reactive.Board;
import org.xmloperator.reactive.exception.IncorrectKeyException;

/**
 * Board providing a RootElement.
 */
public interface ElementBoard extends Board {

	/**
	 * Returns the RootElement of this Board.
	 * @return the RootElement of this Board.
	 */
	public RootElement getRootElement();

	/**
     * Returns a read-write access to a given Element.
     * @param element an Element.
     * @param writingKey the key that allows to write elements.
     * @return a read-write access to a given Element.
     * @exception IncorrectKeyException if the given key is not the good one.
     */
    public RWElement rwElement(Element element, long writingKey)
    	throws IncorrectKeyException;
}
