/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.action;

import java.util.Comparator;

import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ParentElement;
import org.xmloperator.reactive.element.RWParentElement;
import org.xmloperator.reactive.element.ElementBoard;

/**
 * Action of sorting the children of a ParentElement.
 */
public final class ChildrenSortAction extends AbstractElementAction {
	
	public final Comparator<Element> elementComparator;
	
	public ChildrenSortAction(ElementBoard elementBoard,
			ParentElement referenceElement,
			Comparator<Element> elementComparator) {
		super(elementBoard, referenceElement);
		this.elementComparator = elementComparator;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public void execute(long permissionKey) {
		super.execute(permissionKey);
		RWParentElement rwParentElement =
			(RWParentElement)this.elementBoard.rwElement(
				this.referenceElement, permissionKey);
		rwParentElement.sortChildren(this.elementComparator);
	}

	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append("sort");
		sb.append('(');
		sb.append(this.elementComparator);
		sb.append(')');
		return sb.toString();
	}
}
