/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.action;

import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ParentElement;
import org.xmloperator.reactive.element.RWParentElement;
import org.xmloperator.reactive.element.ElementBoard;

/**
 * Action of inserting an Element.
 */
public final class ElementAppendAction extends AbstractElementAction {
	
	public final Element appendedElement;
	
	public ElementAppendAction(ElementBoard elementBoard,
			ParentElement referenceElement, Element appendedElement) {
		super(elementBoard, referenceElement);
		this.appendedElement = appendedElement;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public void execute(long permissionKey) {
		super.execute(permissionKey);
		RWParentElement rwParentElement =
			(RWParentElement)this.elementBoard.rwElement(
				this.referenceElement, permissionKey);
		rwParentElement.appendChild(this.appendedElement);
	}

	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append("append");
		sb.append(this.appendedElement);
		return sb.toString();
	}
}
