/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.constraint;

import org.xmloperator.reactive.element.exception.ChildrenConstraintException;

import org.xmloperator.reactive.element.ChildrenConstraint;
import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ParentElement;

/**
 * And construct of two ChildrenConstraint.
 */
public final class AndChildrenConstraint implements ChildrenConstraint {
	
	private final ChildrenConstraint constraint1;
	private final ChildrenConstraint constraint2;
	
	public AndChildrenConstraint(
			ChildrenConstraint constraint1,
			ChildrenConstraint constraint2) {
		this.constraint1 = constraint1;
		this.constraint2 = constraint2;
	}
	
	/////////////////////
	// ChildrenConstraint
	/////////////////////
	
	public void verifyConstraint(
			ParentElement parentElement,
			Element addedChildElement, boolean isChildAdded)
			throws ChildrenConstraintException {
		this.constraint1.verifyConstraint(parentElement,
				addedChildElement, isChildAdded);
		this.constraint2.verifyConstraint(parentElement,
				addedChildElement, isChildAdded);
	}
	
	////////////////////////
	// Object implementation
	////////////////////////

	public String toString() {
		return this.constraint1.toString()
			+ "&" + this.constraint2.toString();
	}
}
