/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.impl;

import org.xmloperator.reactive.Board;
import org.xmloperator.reactive.ReactiveCommunity;

/**
 * Board implementation.
 */
public abstract class BoardImpl implements Board {
	private final ReactiveCommunity reactiveCommunity;
	protected final long boardPermissionKey;
	
	public BoardImpl(ReactiveCommunity reactiveCommunity, long boardPermissionKey) {
		if (reactiveCommunity == null)
			throw new IllegalArgumentException();
		this.reactiveCommunity = reactiveCommunity;
		this.boardPermissionKey = boardPermissionKey;
	}

	///////////////////////
	// Board implementation
	///////////////////////

	public ReactiveCommunity getCommunity() {
		return this.reactiveCommunity;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.reactiveCommunity + "Board";
	}
}
