/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.impl;

import org.xmloperator.reactive.Message;
import org.xmloperator.reactive.exception.SenderUncertifiableException;

/**
 * Message implementation.
 */
public class MessageImpl implements Message {
	private final int destinationCellNumber;
	private String senderEntityId = null;
	
	public MessageImpl() {
		this.destinationCellNumber = -1;
	}
	
	public MessageImpl(int destinationCellNumber) {
		this.destinationCellNumber = destinationCellNumber;
	}
	
	/////////////////////////
	// Message implementation
	/////////////////////////
	
	public boolean isSimpleMessage() {
		return false;
	}
	
	public boolean isDoubleMessage() {
		return false;
	}

	public boolean isActionMessage() {
		return false;
	}

	public boolean isTraceable() {
		return true;
	}

	public final String getSenderEntityId() {
		return this.senderEntityId;
	}
	
	public final void setSenderEntityId(String senderEntityId) {
		if (senderEntityId == null)
			throw new IllegalArgumentException();
		if (senderEntityId == this.senderEntityId)
			return;
		if (this.senderEntityId != null)
			throw new SenderUncertifiableException();
		this.senderEntityId = senderEntityId;
	}
	
	public final int getDestinationCellNumber() {
		return this.destinationCellNumber;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		return this.senderEntityId;
	}
}
