/*
 * Copyright (c) 2008, 2011 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.impl;

import org.xmloperator.reactive.Operation;
import org.xmloperator.reactive.exception.ActionAlreadyExecutedException;
import org.xmloperator.reactive.exception.ReactiveException;

/**
 * Operation implementation.
 */
public abstract class OperationImpl implements Operation {
	private boolean isExecuted = false; 
	
	///////////////////////////
	// Operation implementation
	///////////////////////////

	public void execute() throws ReactiveException {
		if (this.isExecuted)
			throw new ActionAlreadyExecutedException();
		this.isExecuted = true;
	}
}
